using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Syncfusion.DLS;
using Syncfusion.DocIO;
using Syncfusion.DocIO.DLS;
using System.IO;
using System.Data.SqlClient;

public partial class _Default : System.Web.UI.Page 
{
    int id;
    protected void Page_Load(object sender, EventArgs e)
    {

    }
    protected void Button1_Click(object sender, EventArgs e)
    {
       string dBConnString =
System.Configuration.ConfigurationManager.AppSettings["ConnectionString"];
        SqlConnection Conn = new SqlConnection(dBConnString);

        //save the document to database
        SaveDatabase(Conn);

        //open the document from database
        WordDocument ldoc = new WordDocument(OpenDatabase(Conn));

        //Add bookmarks
        AddBookmarks(ldoc);

        // Creating a memory Stream.
        MemoryStream ms = new MemoryStream();

        // Save the pdf document to the Stream.
        ldoc.Save(ms,FormatType.Doc);
        
        byte[] aPdfDocByteArray = new Byte[ms.Length];
        ms.Seek(0, SeekOrigin.Begin);
        ms.Read(aPdfDocByteArray, 0, System.Convert.ToInt32(ms.Length));
        ms.Seek(0, SeekOrigin.Begin);
        
        MemoryStream formSample = new MemoryStream();
        formSample.Write(aPdfDocByteArray, 0, System.Convert.ToInt32(aPdfDocByteArray.Length));
        formSample.Seek(0, SeekOrigin.Begin);

        Response.ContentType = "application/doc";
        Response.OutputStream.Write(formSample.GetBuffer(), 0, formSample.GetBuffer().Length);
        Response.End();

        // Closing the Stream.
        ms.Close();
    }
    private void AddBookmarks(WordDocument document)
    {

        // Adding a section to the document.
        IWSection section = document.AddSection();

        // Adding a new paragraph to the section.
        IWParagraph paragraph = section.AddParagraph();

        // Writing text to the document with created paragraph.
        paragraph.AppendText("The Bookmarks in this document were inserted using Essential DocIO.");
        // BookmarkStart.
        paragraph.AppendBookmarkStart("Essential_Tools");
        // Write bookmark
        paragraph.AppendText("Essential Tools");
        // BookmarkEnd.
        paragraph.AppendBookmarkEnd("Essential_Tools");
        // Writing text
        paragraph.AppendText("   Collection of great user interface controls including XP style controls and docking windows.");

    }
    private void SaveDatabase(SqlConnection Conn)
    {
        id = 1;
        string command = "INSERT INTO doctable (id,doc) VALUES ('" + id + "',?) ";
        SqlCommand mCommand = new SqlCommand(command, Conn);
        Stream formSample = new MemoryStream();
        formSample = new FileStream(Server.MapPath("sample.doc"), FileMode.Open, FileAccess.ReadWrite);
        byte[] aPdfDocByteArray = new Byte[formSample.Length];
        formSample.Read(aPdfDocByteArray, 0, System.Convert.ToInt32(formSample.Length));
        formSample.Seek(0, SeekOrigin.Begin);

        SqlParameter myParameter = new SqlParameter("@doc", SqlDbType.VarBinary, aPdfDocByteArray.Length);
        myParameter.Value = aPdfDocByteArray;
        mCommand.Parameters.Add(myParameter);

        //open the connection and execute the statement
        Conn.Open();
        mCommand.ExecuteNonQuery();
    }

    private string OpenDatabase(SqlConnection Conn)
    {
        SqlCommand myCommand = new SqlCommand("SELECT doc FROM doctable WHERE id =1", Conn);

        //get the doc from the database
        byte[] DocByteArray = (byte[])myCommand.ExecuteScalar();

        MemoryStream ms = new MemoryStream();
        ms.Write(DocByteArray, 0, System.Convert.ToInt32(DocByteArray.Length));
        ms.Seek(0, SeekOrigin.Begin);
        //Create a FileStream
        FileStream fs = new FileStream("Sample.doc", FileMode.Create);
        ms.WriteTo(fs);
        return "Sample.doc";
			
    }

}
